Package org.optaplanner.core.impl.score.buildin.simpledouble

## Class SimpleDoubleScoreDefinition

- java.lang.Object
- - org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<SimpleDoubleScore>
  - - org.optaplanner.core.impl.score.buildin.simpledouble.SimpleDoubleScoreDefinition

- All Implemented Interfaces:
    `Serializable`, `ScoreDefinition<SimpleDoubleScore>`

      @Deprecated
      public class SimpleDoubleScoreDefinition
      extends AbstractScoreDefinition<SimpleDoubleScore>

  Deprecated.
  Double-based scores are deprecated as floating point numbers are not associative (A + B + C == C + B + A) and therefore they are not compatible with incremental score calculation.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SimpleDoubleScoreDefinition()` | Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `SimpleDoubleScore` | `buildOptimisticBound​(InitializingScoreTrend initializingScoreTrend, SimpleDoubleScore score)` | Deprecated. Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
    `SimpleDoubleScore` | `buildPessimisticBound​(InitializingScoreTrend initializingScoreTrend, SimpleDoubleScore score)` | Deprecated. Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
    `ScoreHolder` | `buildScoreHolder​(boolean constraintMatchEnabled)` | Deprecated. Used by `DroolsScoreDirector`.
    `ScoreInliner<SimpleDoubleScore>` | `buildScoreInliner​(boolean constraintMatchEnabled)` | Deprecated. Used by `BavetConstraintFactory`
    `SimpleDoubleScore` | `divideBySanitizedDivisor​(SimpleDoubleScore dividend, SimpleDoubleScore divisor)` | Deprecated. Return `Score` whose every level is the result of dividing the matching levels in this and the divisor.
    `SimpleDoubleScore` | `fromLevelNumbers​(int initScore, Number[] levelNumbers)` | Deprecated. The opposite of `Score.toLevelNumbers()`.
    `int` | `getFeasibleLevelsSize()` | Deprecated. Returns the number of levels of `Score.toLevelNumbers()`.
    `int` | `getLevelsSize()` | Deprecated. Returns the length of `Score.toLevelNumbers()` for every `Score` of this definition.
    `SimpleDoubleScore` | `getOneSoftestScore()` | Deprecated. The score that represents the softest possible one.
    `Class<SimpleDoubleScore>` | `getScoreClass()` | Deprecated. Returns the `Class` of the actual `Score` implementation.
    `SimpleDoubleScore` | `getZeroScore()` | Deprecated. The score that represents zero.
    `SimpleDoubleScore` | `parseScore​(String scoreString)` | Deprecated. Parses the `String` and returns a `Score`.

    - ### Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition

      `divide, divide, divide, divide, formatScore, getInitLabel, getLevelLabels, isCompatibleArithmeticArgument, sanitize, sanitize, sanitize, sanitize, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.definition.ScoreDefinition

      `isNegativeOrZero, isPositiveOrZero`

- - ### Constructor Detail

    - #### SimpleDoubleScoreDefinition

          public SimpleDoubleScoreDefinition()

      Deprecated.

  - ### Method Detail

    - #### getLevelsSize

          public int getLevelsSize()

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Returns the length of `Score.toLevelNumbers()` for every `Score` of this definition. For example: returns 2 on `HardSoftScoreDefinition`.
      Specified by:
        `getLevelsSize` in interface `ScoreDefinition<SimpleDoubleScore>`
      Overrides:
        `getLevelsSize` in class `AbstractScoreDefinition<SimpleDoubleScore>`
      Returns:
        at least 1

    - #### getFeasibleLevelsSize

          public int getFeasibleLevelsSize()

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Returns the number of levels of `Score.toLevelNumbers()`. that are used to determine `Score.isFeasible()`.
      Returns:
        at least 0, at most `ScoreDefinition.getLevelsSize()`

    - #### getScoreClass

          public Class<SimpleDoubleScore> getScoreClass()

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Returns the `Class` of the actual `Score` implementation. For example: returns `HardSoftScore.class` on `HardSoftScoreDefinition`.
      Returns:
        never null

    - #### getZeroScore

          public SimpleDoubleScore getZeroScore()

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      The score that represents zero.
      Returns:
        never null

    - #### getOneSoftestScore

          public SimpleDoubleScore getOneSoftestScore()

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      The score that represents the softest possible one.
      Returns:
        never null

    - #### parseScore

          public SimpleDoubleScore parseScore​(String scoreString)

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Parses the `String` and returns a `Score`.
      Parameters:
        `scoreString` - never null
      Returns:
        never null
      See Also:
        `ScoreDefinition.formatScore(Score)`, `ScoreUtils.parseScore(Class, String)`

    - #### fromLevelNumbers

          public SimpleDoubleScore fromLevelNumbers​(int initScore,
                                                    Number[] levelNumbers)

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      The opposite of `Score.toLevelNumbers()`.
      Parameters:
        `initScore` - `<= 0`, managed by OptaPlanner, needed as a parameter in the `Score`'s creation method, see `Score.getInitScore()`
        `levelNumbers` - never null
      Returns:
        never null

    - #### buildScoreInliner

          public ScoreInliner<SimpleDoubleScore> buildScoreInliner​(boolean constraintMatchEnabled)

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Used by `BavetConstraintFactory`
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildScoreHolder

          public ScoreHolder buildScoreHolder​(boolean constraintMatchEnabled)

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Used by `DroolsScoreDirector`.
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildOptimisticBound

          public SimpleDoubleScore buildOptimisticBound​(InitializingScoreTrend initializingScoreTrend,
                                                        SimpleDoubleScore score)

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`.
      Returns:
        never null

    - #### buildPessimisticBound

          public SimpleDoubleScore buildPessimisticBound​(InitializingScoreTrend initializingScoreTrend,
                                                         SimpleDoubleScore score)

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`
      Returns:
        never null

    - #### divideBySanitizedDivisor

          public SimpleDoubleScore divideBySanitizedDivisor​(SimpleDoubleScore dividend,
                                                            SimpleDoubleScore divisor)

      Deprecated.
      Description copied from interface: `ScoreDefinition`
      Return `Score` whose every level is the result of dividing the matching levels in this and the divisor. When rounding is needed, it is floored (as defined by `Math.floor(double)`).

      If any of the levels in the divisor are equal to zero, the method behaves as if they were equal to one instead.

        `divisor` - value by which this Score is to be divided
      Returns:
        this / divisor